Attribute VB_Name = "modString"
Option Explicit

Sub Main()

'This sample module can be used to demonstrate the uses of the StringX functions
'as we think it is often better to see code in use in order to understand it how things
'work.
'
'Check the Debug window for the output from each function test.
'
'This is the module we use to test all new releases of StringX, so it may
'have a few odd examples, as we try to break it before we release it.
'
'All the best and happy coding from the StringX team
'
Dim StringX As New StringX

'Work variables
Dim I As Variant
Dim strArray(20) As String
Dim varArray(20) As Variant
Dim lngArray(6) As Long



'=========================================================================
'AddBackSlash
'
'Adds a backslash to a string ONLY if it doesn't have one
'=========================================================================
Debug.Print "AddBackSlash"
I = StringX.AddBackSlash("C:\TEST")
Debug.Print "'" & I & "'"
I = StringX.AddBackSlash("C:\TEST\")
Debug.Print "'" & I & "'"
Debug.Print "*****"
Debug.Print

'=========================================================================
'DeBackSlash
'
'Removes a backslash from the end of a string ONLY if there is one
'=========================================================================
Debug.Print "DeBackSlash"
I = StringX.DeBackSlash("C:\TEST")
Debug.Print "'" & I & "'"
I = StringX.DeBackSlash("C:\TEST\")
Debug.Print "'" & I & "'"
Debug.Print "*****"
Debug.Print
'=========================================================================
'ReplaceCharsFirst
'
'Searches and replaces a string with another
'=========================================================================
Debug.Print "ReplaceCharsFirst"
I = StringX.ReplaceCharsFirst("THIS IS A TEST", "I", "XXX")
Debug.Print "'" & I & "'"
I = StringX.ReplaceCharsFirst("", "I", "XXX")
Debug.Print "'" & I & "'"
I = StringX.ReplaceCharsFirst("THIS IS A TEST", "I", "")
Debug.Print "'" & I & "'"
I = StringX.ReplaceCharsFirst("THIS IS A TEST", "IS A", "NOT A")
Debug.Print "'" & I & "'"
Debug.Print "*****"
Debug.Print
'=========================================================================
'ReplaceCharsAll
'
'Searches and replaces all occurances of a string with another, with options
'for case sensitivity and word matching
'=========================================================================
Debug.Print "ReplaceCharsAll"
I = StringX.ReplaceCharsAll("THIS IS A TEST", "I", "XXX")
Debug.Print "'" & I & "'"
I = StringX.ReplaceCharsAll("", "I", "XXX")
Debug.Print "'" & I & "'"
I = StringX.ReplaceCharsAll("THIS IS A TEST", "I", "")
Debug.Print "'" & I & "'"
I = StringX.ReplaceCharsAll("THIS IS A TEST", "IS A", "IS NOT A")
Debug.Print "'" & I & "'"
I = StringX.ReplaceCharsAll("THIS IS A TEST is a", "is a", "IS NOT A")
Debug.Print "'" & I & "'"
I = StringX.ReplaceCharsAll("XXXXXXXXX", "x", "Y")
Debug.Print "'" & I & "'"
I = StringX.ReplaceCharsAll("XaXaXaXaX", "xa", "YaY")
Debug.Print "'" & I & "'"
I = StringX.ReplaceCharsAll(" ", "", "")
Debug.Print "'" & I & "'"

I = StringX.ReplaceCharsAll("THiS IS A TEST", "i", "XXX", False)
Debug.Print "'" & I & "'"
I = StringX.ReplaceCharsAll("", "I", "XXX", False)
Debug.Print "'" & I & "'"
I = StringX.ReplaceCharsAll("THiS IS i A TEST", "i", "", False)
Debug.Print "'" & I & "'"
I = StringX.ReplaceCharsAll("THiS IS A TEST", "is a", "IS NOT A", False)
Debug.Print "'" & I & "'"
I = StringX.ReplaceCharsAll("THiS IS A is a TEST IS A", "is a", "IS NOT A", False)
Debug.Print "'" & I & "'"
I = StringX.ReplaceCharsAll("XXXxXXxXX", "x", "Y", False)
Debug.Print "'" & I & "'"
I = StringX.ReplaceCharsAll("xaXaxaXaX", "xa", "YaY", False)
Debug.Print "'" & I & "'"
I = StringX.ReplaceCharsAll(" ", "", "", False)
Debug.Print "'" & I & "'"
Debug.Print "*****"

I = StringX.ReplaceCharsAll("THIS IS A TEST", "IS", "XXX", , True)
Debug.Print "'" & I & "'"
I = StringX.ReplaceCharsAll("IS THIS IS A TEST", "IS", "XXX", , True)
Debug.Print "'" & I & "'"
I = StringX.ReplaceCharsAll("THIS IS A TEST IS ISIS IS", "IS", "XXX", , True)
Debug.Print "'" & I & "'"
I = StringX.ReplaceCharsAll("", "I", "XXX", , True)
Debug.Print "'" & I & "'"
I = StringX.ReplaceCharsAll("THIS IS A TEST", "IS", "", , True)
Debug.Print "'" & I & "'"
I = StringX.ReplaceCharsAll("XXXX X XXX X", "X", "Y", , True)
Debug.Print "'" & I & "'"
I = StringX.ReplaceCharsAll("xaXa Xa xaXaX Xa xa", "xa", "YaY", , True)
Debug.Print "'" & I & "'"
I = StringX.ReplaceCharsAll(" ", "", "", , True)
Debug.Print "'" & I & "'"
Debug.Print "*****"


I = StringX.ReplaceCharsAll("THIS IS A TEST", "is", "XXX", False, True)
Debug.Print "'" & I & "'"
I = StringX.ReplaceCharsAll("IS THIS IS A TEST", "is", "XXX", False, True)
Debug.Print "'" & I & "'"
I = StringX.ReplaceCharsAll("THIS IS A TEST IS ISIS IS", "IS", "XXX", False, True)
Debug.Print "'" & I & "'"
I = StringX.ReplaceCharsAll("", "I", "XXX", False, True)
Debug.Print "'" & I & "'"
I = StringX.ReplaceCharsAll("THIS IS A TEST", "is", "", False, True)
Debug.Print "'" & I & "'"
I = StringX.ReplaceCharsAll("XXXX X XXX X", "x", "Y", False, True)
Debug.Print "'" & I & "'"
I = StringX.ReplaceCharsAll("Xa Xa XaXaX", "xa", "YaY", False, True)
Debug.Print "'" & I & "'"
I = StringX.ReplaceCharsAll(" ", "", "", False, True)
Debug.Print "'" & I & "'"
Debug.Print "*****"

Debug.Print

'=========================================================================
'GetDelimited
'
'Gets a string from another depending on a specified delimiter
'=========================================================================
Debug.Print "GetDelimited"
I = StringX.GetDelimited("THIS IS A TEST", 3, " ")
Debug.Print "'" & I & "'"
I = StringX.GetDelimited("XXX@HOTMAIL.COM", 2, "@")
Debug.Print "'" & I & "'"
I = StringX.GetDelimited("XXX@HOTMAIL.COM", 1, "@")
Debug.Print "'" & I & "'"
I = StringX.GetDelimited("", 0, "")
Debug.Print "'" & I & "'"
I = StringX.GetDelimited("THIS,IS,A,TEST", 4, ",")
Debug.Print "'" & I & "'"
I = StringX.GetDelimited("THIS,IS,A,TEST", 9, ",")
Debug.Print "'" & I & "'"
Debug.Print "*****"
Debug.Print
'=========================================================================
'GetDelimitedEx
'
'Gets a string from another depending on a specified delimiter, and within possible 2nd delimiters
'IE for records like "Fred,Smith" ,"John","Peter"
'=========================================================================
Debug.Print "GetDelimitedEx"
I = StringX.GetDelimitedEx("'THIS ','IS, A', 'TEST'", 1, ",", "'")
Debug.Print "'" & I & "'"
I = StringX.GetDelimitedEx("'THIS ','IS, A', 'TEST'", 2, ",", "'")
Debug.Print "'" & I & "'"
I = StringX.GetDelimitedEx("'THIS ','IS, A', 'TEST'", 3, ",", "'")
Debug.Print "'" & I & "'"
I = StringX.GetDelimitedEx("XXX@HOTMAIL.COM", 2, "@", "'")
Debug.Print "'" & I & "'"
I = StringX.GetDelimitedEx("XXX@HOTMAIL.COM", 1, "@", "")
Debug.Print "'" & I & "'"
I = StringX.GetDelimitedEx("", 0, "", ",")
Debug.Print "'" & I & "'"
I = StringX.GetDelimitedEx("THIS,IS,A,TEST", 4, ",", "")
Debug.Print "'" & I & "'"
I = StringX.GetDelimitedEx("THIS,IS,A,TEST", 9, ",", "A")
Debug.Print "'" & I & "'"
Debug.Print "*****"
Debug.Print

'=========================================================================
'StripCharacter
'
'Strips all occurances of a character from string
'=========================================================================
Debug.Print "StripCharacter"
I = StringX.StripCharacter("THIS IS A TEST", " ")
Debug.Print "'" & I & "'"
I = StringX.StripCharacter("THIS IS A TEST", "I")
Debug.Print "'" & I & "'"
I = StringX.StripCharacter("", " ")
Debug.Print "'" & I & "'"
I = StringX.StripCharacter("AAAA", "")
Debug.Print "'" & I & "'"
I = StringX.StripCharacter("", "")
Debug.Print "'" & I & "'"
Debug.Print "*****"
Debug.Print

'=========================================================================
'StripCharList
'
'Strips all occurances of a list of characters from a string
'=========================================================================
Debug.Print "StripCharList"
I = StringX.StripCharList("THIS IS A TEST", "IT")
Debug.Print "'" & I & "'"
I = StringX.StripCharList("THIS IS A TEST", "HIS")
Debug.Print "'" & I & "'"
I = StringX.StripCharList("", " ")
Debug.Print "'" & I & "'"
I = StringX.StripCharList("AAAA", "ABC")
Debug.Print "'" & I & "'"
I = StringX.StripCharList("", "")
Debug.Print "'" & I & "'"
Debug.Print "*****"
Debug.Print
'=========================================================================
'StripCharNotInList
'
'Strips all occurances of a list of characters from a string
'=========================================================================
'Debug.Print "StripCharNotInList"
'I = StringX.StripCharNotInList("THIS IS A TEST", "IT")
'Debug.Print "'" & I & "'"
'I = StringX.StripCharNotInList("THIS IS A TEST", "HIS")
'Debug.Print "'" & I & "'"
'I = StringX.StripCharNotInList("", " ")
'Debug.Print "'" & I & "'"
'I = StringX.StripCharNotInList("AAAA", "ABC")
'Debug.Print "'" & I & "'"
'I = StringX.StripCharNotInList("", "")
'Debug.Print "'" & I & "'"
'Debug.Print "*****"
'Debug.Print
'=========================================================================
'StripString
'
'Strips all occurances of a string from string
'=========================================================================
Debug.Print "StripString"
I = StringX.StripString("THIS IS A TEST", "IS")
Debug.Print "'" & I & "'"
I = StringX.StripString("THIS IS A TEST", "TEST")
Debug.Print "'" & I & "'"
I = StringX.StripString("", " ")
Debug.Print "'" & I & "'"
I = StringX.StripString("AAAA", "")
Debug.Print "'" & I & "'"
I = StringX.StripString("", "")
Debug.Print "'" & I & "'"
I = StringX.StripString("xHELLOx", "HELLO")
Debug.Print "'" & I & "'"
I = StringX.StripString("HELLO", "HELLO")
Debug.Print "'" & I & "'"
Debug.Print "*****"
Debug.Print
'=========================================================================
'WordCount
'
'Counts the number of words in a string
'=========================================================================
Debug.Print "WordCount"
I = StringX.WordCount("THIS IS A TEST")
Debug.Print "'" & I & "'"
I = StringX.WordCount("THIS IS.A TEST")
Debug.Print "'" & I & "'"
I = StringX.WordCount("THIS IS. A TEST.")
Debug.Print "'" & I & "'"
I = StringX.WordCount("")
Debug.Print "'" & I & "'"
I = StringX.WordCount("THIS")
Debug.Print "'" & I & "'"
I = StringX.WordCount(".THIS.")
Debug.Print "'" & I & "'"
I = StringX.WordCount("  ")
Debug.Print "'" & I & "'"
Debug.Print "*****"
Debug.Print
'=========================================================================
'WordPos
'
'Returns position of the nth word in a string
'=========================================================================
Debug.Print "WordPos"
I = StringX.WordPos("THIS IS A TEST", 3)
Debug.Print "'" & I & "'"
I = StringX.WordPos("THIS IS.A TEST", 3)
Debug.Print "'" & I & "'"
I = StringX.WordPos("THIS IS. A TEST.", 4)
Debug.Print "'" & I & "'"
I = StringX.WordPos("", 3)
Debug.Print "'" & I & "'"
I = StringX.WordPos("THIS", 1)
Debug.Print "'" & I & "'"
I = StringX.WordPos(".THIS.", 1)
Debug.Print "'" & I & "'"
I = StringX.WordPos("  ", 0)
Debug.Print "'" & I & "'"
Debug.Print "*****"
Debug.Print
'=========================================================================
'WordPosLen
'
'Returns the Length of the nth word in a string
'=========================================================================
Debug.Print "WordPosLen"
I = StringX.WordPosLen("THIS IS A TEST", 3)
Debug.Print "'" & I & "'"
I = StringX.WordPosLen("THIS IS ANOTHER TEST", 3)
Debug.Print "'" & I & "'"
I = StringX.WordPosLen("THIS IS ANOTHER. TEST", 3)
Debug.Print "'" & I & "'"
I = StringX.WordPosLen("THIS IS.ANOTHER TEST", 4)
Debug.Print "'" & I & "'"
I = StringX.WordPosLen("THIS IS.ANOTHER.TEST", 3)
Debug.Print "'" & I & "'"
I = StringX.WordPosLen("THIS", 1)
Debug.Print "'" & I & "'"
I = StringX.WordPosLen("THIS ", 1)
Debug.Print "'" & I & "'"
I = StringX.WordPosLen(".THIS.", 1)
Debug.Print "'" & I & "'"
I = StringX.WordPosLen("THIS", 2)
Debug.Print "'" & I & "'"
I = StringX.WordPosLen("  ", 0)
Debug.Print "'" & I & "'"
Debug.Print "*****"
Debug.Print
'=========================================================================
'InsertString
'
'Inserts one string into another
'=========================================================================
Debug.Print "InsertString"
I = StringX.InsertString("THIS IS A TEST", "FANTASTIC ", 10)
Debug.Print "'" & I & "'"
I = StringX.InsertString("", "FANTASTIC ", 10)
Debug.Print "'" & I & "'"
I = StringX.InsertString("THIS IS A TEST", "", 10)
Debug.Print "'" & I & "'"
I = StringX.InsertString("THIS IS A TEST", "FANTASTIC ", 0)
Debug.Print "'" & I & "'"
I = StringX.InsertString("", "", 10)
Debug.Print "'" & I & "'"
Debug.Print "*****"
Debug.Print
'=========================================================================
'NumericToWords
'
'Gives word representation of numerics (for cheques etc)
'=========================================================================
Debug.Print "NumericToWords"
I = StringX.NumericToWords("101")
Debug.Print "'" & I & "'"
I = StringX.NumericToWords("121")
Debug.Print "'" & I & "'"
I = StringX.NumericToWords("1001")
Debug.Print "'" & I & "'"
I = StringX.NumericToWords("1101")
Debug.Print "'" & I & "'"
I = StringX.NumericToWords("10001")
Debug.Print "'" & I & "'"
I = StringX.NumericToWords("10301")
Debug.Print "'" & I & "'"
I = StringX.NumericToWords("231001")
Debug.Print "'" & I & "'"
I = StringX.NumericToWords("323101")
Debug.Print "'" & I & "'"
I = StringX.NumericToWords("100010")
Debug.Print "'" & I & "'"
I = StringX.NumericToWords("5000010")
Debug.Print "'" & I & "'"
I = StringX.NumericToWords("6002010")
Debug.Print "'" & I & "'"
I = StringX.NumericToWords("10000010")
Debug.Print "'" & I & "'"
I = StringX.NumericToWords("4342300")
Debug.Print "'" & I & "'"
I = StringX.NumericToWords("4301300")
Debug.Print "'" & I & "'"
I = StringX.NumericToWords("1")
Debug.Print "'" & I & "'"
I = StringX.NumericToWords("1000000")
Debug.Print "'" & I & "'"
I = StringX.NumericToWords("12300001")
Debug.Print "'" & I & "'"
I = StringX.NumericToWords("10000001")
Debug.Print "'" & I & "'"
I = StringX.NumericToWords("10000000001")
Debug.Print "'" & I & "'"
I = StringX.NumericToWords("1000030000001")
Debug.Print "'" & I & "'"
I = StringX.NumericToWords("9999999999999")
Debug.Print "'" & I & "'"
Debug.Print "*****"
Debug.Print
'=========================================================================
'Numerictowordswithand
'
'Gives word representation of numerics (for cheques etc) with 'ands' (UK)
'=========================================================================
Debug.Print "NumericToWordsWithAnd"
I = StringX.NumericToWordsWithAND("101")
Debug.Print "'" & I & "'"
I = StringX.NumericToWordsWithAND("121")
Debug.Print "'" & I & "'"
I = StringX.NumericToWordsWithAND("1001")
Debug.Print "'" & I & "'"
I = StringX.NumericToWordsWithAND("1101")
Debug.Print "'" & I & "'"
I = StringX.NumericToWordsWithAND("10001")
Debug.Print "'" & I & "'"
I = StringX.NumericToWordsWithAND("10301")
Debug.Print "'" & I & "'"
I = StringX.NumericToWordsWithAND("231001")
Debug.Print "'" & I & "'"
I = StringX.NumericToWordsWithAND("323101")
Debug.Print "'" & I & "'"
I = StringX.NumericToWordsWithAND("100010")
Debug.Print "'" & I & "'"
I = StringX.NumericToWordsWithAND("5000010")
Debug.Print "'" & I & "'"
I = StringX.NumericToWordsWithAND("6002010")
Debug.Print "'" & I & "'"
I = StringX.NumericToWordsWithAND("10000010")
Debug.Print "'" & I & "'"
I = StringX.NumericToWordsWithAND("4342300")
Debug.Print "'" & I & "'"
I = StringX.NumericToWordsWithAND("4301300")
Debug.Print "'" & I & "'"
I = StringX.NumericToWordsWithAND("1")
Debug.Print "'" & I & "'"
I = StringX.NumericToWordsWithAND("1000000")
Debug.Print "'" & I & "'"
I = StringX.NumericToWordsWithAND("12300001")
Debug.Print "'" & I & "'"
I = StringX.NumericToWordsWithAND("10000001")
Debug.Print "'" & I & "'"
I = StringX.NumericToWordsWithAND("10000000001")
Debug.Print "'" & I & "'"
I = StringX.NumericToWordsWithAND("1000030000001")
Debug.Print "'" & I & "'"
I = StringX.NumericToWordsWithAND("9999999999999")
Debug.Print "'" & I & "'"
Debug.Print "*****"
Debug.Print
'=========================================================================
'TrimUnprintable
'
'Trim all chars below x'20'
'=========================================================================
Debug.Print "TrimUnprintable"
I = StringX.TrimUnprintable(Chr$(31) & Chr$(31) & "TEST" & Chr$(0) & Chr$(30))
Debug.Print "'" & I & "'"
I = StringX.TrimUnprintable("   TEST" & Chr$(0) & Chr$(30))
Debug.Print "'" & I & "'"
I = StringX.TrimUnprintable("")
Debug.Print "'" & I & "'"
Debug.Print "*****"
Debug.Print
'=========================================================================
'Asciitoebcdic
'
'Converts string from ASCII to EBCDIC
'=========================================================================
Debug.Print "AsciiToEbcdic"
I = StringX.AsciiToEbcdic("THIS IS A TEST 123")
Debug.Print "'" & I & "'"
Debug.Print "*****"
Debug.Print
'=========================================================================
'ebcdictoascii
'
'Converts string from EBCDIC to ASCII
'=========================================================================
Debug.Print "EbcdicToAscii"
I = StringX.EbcdicToAscii("@@@@")
Debug.Print "'" & I & "'"
Debug.Print "*****"
Debug.Print
'=========================================================================
'SortArray
'
'Sort an array (examples for text, numeric and binary)
'=========================================================================
Debug.Print "SortArrayText"

strArray(1) = "mY TEST"
strArray(2) = "LAST TEST"
strArray(3) = "a TEST"
strArray(4) = "3 TEST"
strArray(5) = "9 TEST"
strArray(6) = "1 TEST"

lngArray(1) = 4
lngArray(2) = 2
lngArray(3) = 3
lngArray(4) = 7
lngArray(5) = 5
lngArray(6) = 6


I = StringX.SortArrayNumeric(lngArray, 0)
For I = 0 To UBound(lngArray())
Debug.Print "'" & lngArray(I) & "'"
Next I
Debug.Print "*****"

I = StringX.SortArrayNumericDescending(lngArray, 0)
For I = 0 To UBound(lngArray())
Debug.Print "'" & lngArray(I) & "'"
Next I
Debug.Print "*****"


I = StringX.SortArrayText(strArray, 1, 3)
For I = 0 To UBound(strArray())
Debug.Print "'" & strArray(I) & "'"
Next I
Debug.Print "*****"

I = StringX.SortArrayText(strArray, 0)
For I = 0 To UBound(strArray())
Debug.Print "'" & strArray(I) & "'"
Next I
Debug.Print "*****"

I = StringX.SortArrayTextDescending(strArray, 1, 2)
For I = 0 To UBound(strArray())
Debug.Print "'" & strArray(I) & "'"
Next I
Debug.Print "*****"

I = StringX.SortArrayTextDescending(strArray, , 6)
For I = 0 To UBound(strArray())
Debug.Print "'" & strArray(I) & "'"
Next I
Debug.Print "*****"

I = StringX.SortArrayBinary(strArray, 1, 3)
For I = 0 To UBound(strArray())
Debug.Print "'" & strArray(I) & "'"
Next I
Debug.Print "*****"

I = StringX.SortArrayBinary(strArray, 0)
For I = 0 To UBound(strArray())
Debug.Print "'" & strArray(I) & "'"
Next I
Debug.Print "*****"

I = StringX.SortArrayBinaryDescending(strArray, 1, 2)
For I = 0 To UBound(strArray())
Debug.Print "'" & strArray(I) & "'"
Next I
Debug.Print "*****"

I = StringX.SortArrayBinaryDescending(strArray, , 6)

For I = 0 To UBound(strArray())
Debug.Print "'" & strArray(I) & "'"
Next I

Debug.Print "*****"

'=========================================================================
'LastInstr
'
'Gets last occurance of a string
'=========================================================================
Debug.Print "LastInstr"
I = StringX.LastInstr("THIS IS A TEST IS", "IS")
Debug.Print "'" & I & "'"
I = StringX.LastInstr("THIS IS A TEST IS", "IS", 10)
Debug.Print "'" & I & "'"
I = StringX.LastInstr("THIS is A TEST IS", "is", , True)
Debug.Print "'" & I & "'"
I = StringX.LastInstr("   TEST", " ")
Debug.Print "'" & I & "'"
I = StringX.LastInstr("", "")
Debug.Print "'" & I & "'"
I = StringX.LastInstr(" ", "")
Debug.Print "'" & I & "'"
Debug.Print "*****"
Debug.Print

'=========================================================================
'IsAlphaNumeric
'
'Checks if a string is alphanumeric
'=========================================================================
Debug.Print "IsAlphaNumeric"
I = StringX.IsAlphaNumeric("A")
Debug.Print "'" & I & "'"
I = StringX.IsAlphaNumeric("123AAD21")
Debug.Print "'" & I & "'"
I = StringX.IsAlphaNumeric("A-3232")
Debug.Print "'" & I & "'"
I = StringX.IsAlphaNumeric(" ")
Debug.Print "'" & I & "'"
I = StringX.IsAlphaNumeric("")
Debug.Print "'" & I & "'"
Debug.Print "*****"
Debug.Print
'=========================================================================
'ItemCount
'
'Counts the number of occurances of a string within another
'=========================================================================
Debug.Print "ItemCount"
I = StringX.ItemCount("ABSDABDSE", "A")
Debug.Print "'" & I & "'"
Debug.Print "ItemCount"
I = StringX.ItemCount("ABSDABDSEDAB", "DAB")
Debug.Print "'" & I & "'"
Debug.Print "ItemCount"
I = StringX.ItemCount("ABSDABDSE", "ABD")
Debug.Print "'" & I & "'"
Debug.Print "*****"
Debug.Print
'=========================================================================
'Pluck
'
'Gets a string from a set of delimiters
'=========================================================================
Debug.Print "Pluck"
I = StringX.Pluck("(ABSDABDSE)", "(", ")")
Debug.Print "'" & I & "'"
I = StringX.Pluck("[ABSDAE]24343", "[", "]")
Debug.Print "'" & I & "'"
Debug.Print "*****"
Debug.Print

''=========================================================================
''PackedDecimalToString
'
'Converts MVS pack decimal StrIn to decimal
''=========================================================================
Debug.Print "PackedDecimalToString"
Dim x As String
x = StringX.Hex2String("03324D")
I = StringX.PackedDecimalToString(x)
Debug.Print "'" & I & "'"
x = StringX.Hex2String("4D")
I = StringX.PackedDecimalToString(x)
Debug.Print "'" & I & "'"
x = StringX.Hex2String("004D")
I = StringX.PackedDecimalToString(x)
Debug.Print "'" & I & "'"
x = StringX.Hex2String("040D")
I = StringX.PackedDecimalToString(x)
Debug.Print "'" & I & "'"

x = StringX.Hex2String("21000C")
I = StringX.PackedDecimalToString(x)
Debug.Print "'" & I & "'"
x = Chr$(&H3C)                             '   3
I = StringX.PackedDecimalToString(x)
x = StringX.Hex2String("03322322314D")
I = StringX.PackedDecimalToString(x)
Debug.Print "'" & I & "'"
Debug.Print "'" & I & "'"
Debug.Print "*****"
Debug.Print
'=========================================================================
''StringToPackedDecimal
'
'Converts StrIn to MVS pack decimal
''=========================================================================
Debug.Print "StringToPackedDecimal"


I = StringX.StringToPackedDecimal("0012323")
Debug.Print "'" & I & "'"
Debug.Print StringX.string2hex(CStr(I))
I = StringX.StringToPackedDecimal("-123")
Debug.Print "'" & I & "'"
Debug.Print StringX.string2hex(CStr(I))
I = StringX.StringToPackedDecimal("3232.232")
Debug.Print "'" & I & "'"
Debug.Print StringX.string2hex(CStr(I))
Debug.Print "*****"
Debug.Print
'=========================================================================
''StringToPackedDecimal
'
'Converts StrIn to MVS pack decimal and forces the destination length (in bytes)
''=========================================================================
Debug.Print "StringToPackedDecimalWithLen"

I = StringX.StringToPackedDecimalWithLen("12323", 6)
Debug.Print "'" & I & "'"
Debug.Print StringX.string2hex(CStr(I))
I = StringX.StringToPackedDecimalWithLen("-232131232", 10)
Debug.Print "'" & I & "'"
Debug.Print StringX.string2hex(CStr(I))
I = StringX.StringToPackedDecimalWithLen("3232.232", 7)
Debug.Print "'" & I & "'"
Debug.Print StringX.string2hex(CStr(I))
I = StringX.StringToPackedDecimalWithLen("12632232", 1)
Debug.Print "'" & I & "'"
Debug.Print "*****"
Debug.Print
'=========================================================================
''FormatPhoneNumber
'
' Formats a phone number nnn-nnn-nnnn
''=========================================================================
Debug.Print "FormatPhoneNumber"
I = StringX.FormatPhoneNumber("123234232")
Debug.Print "'" & I & "'"
I = StringX.FormatPhoneNumber("5454423234232")
Debug.Print "'" & I & "'"
Debug.Print "*****"
Debug.Print
''=========================================================================
''FormatCreditCard
'
'Formats number for credit cards nnnn nnnn nnnn nnnn
''=========================================================================
Debug.Print "FormatCreditCard"
I = StringX.FormatCreditCard("1232342322222211")
Debug.Print "'" & I & "'"
I = StringX.FormatCreditCard("5454423234232211")
Debug.Print "'" & I & "'"
Debug.Print "*****"
Debug.Print
''=========================================================================
''FilterString
'
'StrIn has all characters that are not in ValidChars removed
''=========================================================================
Debug.Print "FilterString"
I = StringX.FilterString("1232342323232", "123")
Debug.Print "'" & I & "'"
I = StringX.FilterString("A3343", "3")
Debug.Print "'" & I & "'"
Debug.Print "*****"
Debug.Print
''=========================================================================
''FilterNumber
'
'Text has all non numerics remove excluding '.' and '-' and optionally remove any trailing zeroes
''=========================================================================
Debug.Print "FilterNumber"
I = StringX.FilterNumber("-002323.42A", False)
Debug.Print "'" & I & "'"
I = StringX.FilterNumber("0A032S01.3X20", True)
Debug.Print "'" & I & "'"
Debug.Print "*****"
Debug.Print
''=========================================================================
''Dec2Bin
'
'Converts decimal to binary
''=========================================================================
Debug.Print "Dec2Bin"
I = StringX.Dec2Bin("2")
Debug.Print "'" & I & "'"
I = StringX.Dec2Bin("33")
Debug.Print "'" & I & "'"
I = StringX.Dec2Bin("232342")
Debug.Print "'" & I & "'"
I = StringX.Dec2Bin("0032132")
Debug.Print "'" & I & "'"
Debug.Print "*****"
Debug.Print

''=========================================================================
''Bin2Dec
'
'Converts binary to decimal
''=========================================================================
Debug.Print "Bin2Dec"
I = StringX.Bin2Dec("1011010101")
Debug.Print "'" & I & "'"
I = StringX.Bin2Dec("10")
Debug.Print "'" & I & "'"
I = StringX.Bin2Dec("10000001")
Debug.Print "'" & I & "'"
I = StringX.Bin2Dec("110100010101010001010100100101001001010")
Debug.Print "'" & I & "'"
Debug.Print "*****"
Debug.Print


''=========================================================================
''CalcBarcodeLUHN
'
' Calculates a LUHN number for a 22 char barcode string
''=========================================================================
Debug.Print "CalcBarcodeLUHN"
I = StringX.CalcBarcodeLUHN("2123456893123456892132")
Debug.Print "'" & I & "'"
I = StringX.CalcBarcodeLUHN("6123456895323456892332")
Debug.Print "'" & I & "'"
Debug.Print "*****"
Debug.Print

''=========================================================================
''ProperCase
'
'Converts a string to proper case allowing for titles etc and postcodes.
'very powerful
''=========================================================================
Debug.Print "ProperCase"

I = StringX.ProperCase("LOWELL B. ""BJ"" PARKERSON")
Debug.Print "'" & I & "'"
I = StringX.ProperCase("LOWELL B. BJ PARKERSON")
Debug.Print "'" & I & "'"
I = StringX.ProperCase("LOWELL B. (BJ) PARKERSON")
Debug.Print "'" & I & "'"
I = StringX.ProperCase("LOWELL B. ""TEST"" PARKERSON")
Debug.Print "'" & I & "'"
I = StringX.ProperCase("ANDERSON, SC 29625")
Debug.Print "'" & I & "'"
I = StringX.ProperCase("mr and mrs smith ibm (uk)")
Debug.Print "'" & I & "'"
I = StringX.ProperCase("dr fred bishop ltd")
Debug.Print "'" & I & "'"
I = StringX.ProperCase("dr 'FrEdDy' bishop ltd")
Debug.Print "'" & I & "'"
I = StringX.ProperCase("miss julie ann smith")
Debug.Print "'" & I & "'"
I = StringX.ProperCase("we live in [The 'PARKway']")
Debug.Print "'" & I & "'"
I = StringX.ProperCase("mr f.bloggs-simpson 'and' sons")
Debug.Print "'" & I & "'"
I = StringX.ProperCase("(mr f.bloggs-simpson 'and' sons)")
Debug.Print "'" & I & "'"
I = StringX.ProperCase("           ,        mr and mrs")
Debug.Print "'" & I & "'"

Debug.Print "*****"
Debug.Print

''=========================================================================
''InstrWord
'
' Finds a 'word' within a string
'
''=========================================================================
Debug.Print "InstrWord"
I = StringX.InstrWord(1, "THIS IS A TEST", "IS")
Debug.Print "'" & I & "'"
I = StringX.InstrWord(1, "IS. IS A TEST", "IS")
Debug.Print "'" & I & "'"
I = StringX.InstrWord(1, "THISIS A TE IS is", "is", True)
Debug.Print "'" & I & "'"
I = StringX.InstrWord(1, "ISIS", "IS")
Debug.Print "'" & I & "'"
I = StringX.InstrWord(5, "IS IS IS. IS IS", "IS")
Debug.Print "'" & I & "'"
Debug.Print "*****"
Debug.Print

''=========================================================================
''InstrWordRev
'
' Finds a 'word' within a string starting from the end working backwards
'
''=========================================================================
Debug.Print "InstrWordRev"
I = StringX.InstrWordRev("THIS IS A TEST", "IS")
Debug.Print "'" & I & "'"
I = StringX.InstrWordRev("IS IS. A TEST", "IS")
Debug.Print "'" & I & "'"
I = StringX.InstrWordRev("THISIS A TE IS ISIS", "IS")
Debug.Print "'" & I & "'"
I = StringX.InstrWordRev("ISIS", "IS")
Debug.Print "'" & I & "'"
I = StringX.InstrWordRev("IS IS IS IS IS", "IS", 5)
Debug.Print "'" & I & "'"
I = StringX.InstrWordRev("THIS IS is. A TEST", "is", , True)
Debug.Print "'" & I & "'"
Debug.Print "*****"
Debug.Print

''=========================================================================
''InstrNotInList
'
' Finds the first character position not in a list.
'
''=========================================================================
Debug.Print "InstrNotInList"
I = StringX.InstrNotInList(1, "THIS IS A TEST", "ISTH")
Debug.Print "'" & I & "'"
I = StringX.InstrNotInList(1, "THIS IS A TEST", "T")
Debug.Print "'" & I & "'"
I = StringX.InstrNotInList(1, "THIS IS A TEST", "")
Debug.Print "'" & I & "'"
I = StringX.InstrNotInList(4, "DDDAAABBBCCCDDEE", "EABC")
Debug.Print "'" & I & "'"
Debug.Print "*****"
Debug.Print
''=========================================================================
''InstrNotInListRev
'
' Finds the first character position not in a list, starting from the end
' working backwards
'
''=========================================================================
Debug.Print "InstrNotInListRev"
I = StringX.InstrNotInListRev("THIS IS A TEST", "ISTH")
Debug.Print "'" & I & "'"
I = StringX.InstrNotInListRev("THIS IS A TEST", "T")
Debug.Print "'" & I & "'"
I = StringX.InstrNotInListRev("THIS IS A TEST", "")
Debug.Print "'" & I & "'"
I = StringX.InstrNotInListRev("AADDABBBCCCEEDDD", "EABC", 13)
Debug.Print "'" & I & "'"
Debug.Print "*****"
Debug.Print

''=========================================================================
''Hex2String
'
' Converts hex string StrIn (ie "0A23CB") into the equivalent byte string
'
''=========================================================================
Debug.Print "Hex2String"
I = StringX.Hex2String("46524544")
Debug.Print "'" & I & "'"
I = StringX.Hex2String("032023020AADAC")
Debug.Print "'" & I & "'"
I = StringX.Hex2String("00")
Debug.Print "'" & I & "'"
Debug.Print "*****"
Debug.Print

''=========================================================================
''String2Hex
'
' Converts a string into a string with the equivalent hex representation
'
''=========================================================================
Debug.Print "String2Hex"
I = StringX.string2hex("<")
Debug.Print "'" & I & "'"
I = StringX.string2hex("FRED")
Debug.Print "'" & I & "'"
Debug.Print "*****"
Debug.Print

''=========================================================================
''Hex2Dec
'
' Converts a hex string into a decimal number
'
''=========================================================================
Debug.Print "Hex2Dec"
I = StringX.Hex2Dec("02A3")
Debug.Print "'" & I & "'"
I = StringX.Hex2Dec("40ABCA")
Debug.Print "'" & I & "'"
I = StringX.Hex2Dec("G32")
Debug.Print "'" & I & "'"

Debug.Print "*****"
Debug.Print

''=========================================================================
''Dec2Hex
'
' Converts a decimal to hexadecimal
'
''=========================================================================
Debug.Print "Dec2Hex"
I = StringX.Dec2Hex("23123")
Debug.Print "'" & I & "'"
I = StringX.Dec2Hex("23123122")
Debug.Print "'" & I & "'"
I = StringX.Dec2Hex("")
Debug.Print "'" & I & "'"
Debug.Print "*****"
Debug.Print

''=========================================================================
''DeleteString
'
' Deletes a string from another string, with start and length
'
''=========================================================================
Debug.Print "DeleteString"
I = StringX.DeleteString("THIS IS A VERY LARGE TEST", 5, 10)
Debug.Print "'" & I & "'"
I = StringX.DeleteString("THIS LARGE TEST", 5, 1)
Debug.Print "'" & I & "'"
Debug.Print "*****"
Debug.Print

''=========================================================================
''PadAlignString
'
' takes a string and aligns it within a string of a specified length, padded with pad char
' Alignment can be 0=left,1=centre,2=right
'
''=========================================================================
Debug.Print "PadAlignString"
I = StringX.PadAlignString("THIS IS A TEST", 40, , " ")
Debug.Print "'" & I & "'"
I = StringX.PadAlignString("THIS LARGE TEST", 40, vbRightJustify, " ")
Debug.Print "'" & I & "'"
I = StringX.PadAlignString("THIS LARGE TEST", 40, vbCenter, " ")
Debug.Print "'" & I & "'"
I = StringX.PadAlignString("THIS LARGE TEST", 30, vbCenter, "X")
Debug.Print "'" & I & "'"
I = StringX.PadAlignString("THIS LARGE TEST", 40, vbCenter, "Y")
Debug.Print "'" & I & "'"
I = StringX.PadAlignString("THIS LARGE TEST", 40, 3, "")
Debug.Print "'" & I & "'"
I = StringX.PadAlignString("THIS LARGE TEST", 10, vbRightJustify, " ")
Debug.Print "'" & I & "'"
Debug.Print "*****"
Debug.Print

''=========================================================================
''IsPostcodeUK
'
' Verifies if a string is a valid UK Postcode
'
''=========================================================================
Debug.Print "IsPostCodeUK"
I = StringX.IsPostcodeUK("SS9 1Dx")
Debug.Print "'" & I & "'"
I = StringX.IsPostcodeUK("THIS LARGE TEST")
Debug.Print "'" & I & "'"
I = StringX.IsPostcodeUK("W1 8EG")
Debug.Print "'" & I & "'"
I = StringX.IsPostcodeUK("223 WADS")
Debug.Print "'" & I & "'"
I = StringX.IsPostcodeUK("GET 1111")
Debug.Print "'" & I & "'"
I = StringX.IsPostcodeUK("e1 8eG")
Debug.Print "'" & I & "'"
I = StringX.IsPostcodeUK("       e1 8eG   ")
Debug.Print "'" & I & "'"
I = StringX.IsPostcodeUK("EEE FFF")
Debug.Print "'" & I & "'"

Debug.Print "*****"
Debug.Print

''=========================================================================
''IsLeapYear
'
' Verifies if a year is a leap year
'
''=========================================================================
Debug.Print "IsLeapYear"
I = StringX.IsLeapYear(1999)
Debug.Print "'" & I & "'"
I = StringX.IsLeapYear(2000)
Debug.Print "'" & I & "'"
I = StringX.IsLeapYear(2004)
Debug.Print "'" & I & "'"
I = StringX.IsLeapYear(2100)
Debug.Print "'" & I & "'"
I = StringX.IsLeapYear(2400)
Debug.Print "'" & I & "'"
I = StringX.IsLeapYear(1900)
Debug.Print "'" & I & "'"
I = StringX.IsLeapYear(1984)
Debug.Print "'" & I & "'"
Debug.Print "*****"
Debug.Print

''=========================================================================
''DeDuplicate
'
' Replaces all multiple occurances of a string with a single occurrance
' ie "THIS IS  A    TEST"," "
' gives
' "THIS IS A TEST"
''=========================================================================
Debug.Print "DeDuplicate"
I = StringX.DeDuplicate("THIS.IS.A..A...A.TEST", ".")
Debug.Print "'" & I & "'"
I = StringX.DeDuplicate("THIS IS AA AA TEST", "A")
Debug.Print "'" & I & "'"
I = StringX.DeDuplicate("THIS IS A  A   A TEST", " ")
Debug.Print "'" & I & "'"
Debug.Print "*****"
Debug.Print

''=========================================================================
''StringRepeat
'
' Creates a string from a repitition of another.

' =========================================================================
Debug.Print "StringRepeat"
I = StringX.StringRepeat("TEST", 10)
Debug.Print "'" & I & "'"
I = StringX.StringRepeat("THIS IS A", 2)
Debug.Print "'" & I & "'"
I = StringX.StringRepeat("XXX.", 0)
Debug.Print "'" & I & "'"
I = StringX.StringRepeat("VERY LONG BUT VERY FAST!", 10000)
Debug.Print "*****"
Debug.Print

''=========================================================================
''Word
'
' Gets a word from a string

' =========================================================================
Debug.Print "Word"
I = StringX.Word("THIS IS A TEST", 4)
Debug.Print "'" & I & "'"
I = StringX.Word("THIS IS A TEST", 1)
Debug.Print "'" & I & "'"
I = StringX.Word("THIS IS A TEST", 2)
Debug.Print "'" & I & "'"
I = StringX.Word("THIS", 1)
Debug.Print "'" & I & "'"
I = StringX.Word("THIS IS.A.TEST", 4)
Debug.Print "'" & I & "'"
I = StringX.Word("THIS. IS A TEST", 1)
Debug.Print "'" & I & "'"
I = StringX.Word("THIS IS. A TEST", 2)
Debug.Print "'" & I & "'"
I = StringX.Word("THIS.", 1)
Debug.Print "'" & I & "'"
I = StringX.Word("A TEST", 4)
Debug.Print "'" & I & "'"
I = StringX.Word("", 0)
Debug.Print "'" & I & "'"

Debug.Print "*****"
Debug.Print

''=========================================================================
''WorpWrap
' Word wraps a string according to wraplength and creates an array accordingly.
' Options for adding a hyphen for split words
' Returns number of split lines produced
'
' =========================================================================

Debug.Print "WordWrap"
For I = 0 To StringX.WordWrap("this is a test of wordwrapping. Does it work? I wonder I do indeed wonder", 10, strArray)
Debug.Print "'" & strArray(I) & "'"
Next I
For I = 0 To StringX.WordWrap("Right! Now this is another test surely this wiiiiiiiiiiiiiiil breaaaaaaaaaaaakkkkkk it won't it? Does it work? I wonder I do indeed wonder", 10, strArray)
Debug.Print "'" & strArray(I) & "'"
Next I
For I = 0 To StringX.WordWrap("Test", 2, strArray)
Debug.Print "'" & strArray(I) & "'"
Next I
For I = 0 To StringX.WordWrap("this is a test of wordwrapping. Does it work? I wonder I do indeed wonder", 20, strArray)
Debug.Print "'" & strArray(I) & "'"
Next I
For I = 0 To StringX.WordWrap("this is a test of wordwrapping. Does it work? I wonder I do indeed wonder", 10, strArray, False)
Debug.Print "'" & strArray(I) & "'"
Next I
For I = 0 To StringX.WordWrap("Right! Now this is another test surely this wiiiiiiiiiiiiiiil breaaaaaaaaaaaakkkkkk it won't it? Does it work? I wonder I do indeed wonder", 10, strArray, False)
Debug.Print "'" & strArray(I) & "'"
Next I
For I = 0 To StringX.WordWrap("Test", 2, strArray, False)
Debug.Print "'" & strArray(I) & "'"
Next I
For I = 0 To StringX.WordWrap("this is a test of wordwrapping. Does it work? I wonder I do indeed wonder", 20, strArray, False)
Debug.Print "'" & strArray(I) & "'"
Next I
Debug.Print "*****"
Debug.Print

''=========================================================================
''WorpWrapVar
' Word wraps a string according to wraplength and creates an Variant array accordingly.
' Options for adding a hyphen for split words
' Returns number of split lines produced
'
' =========================================================================

Debug.Print "WordWrapVar"
For I = 0 To StringX.WordWrapVar("this is a test of wordwrapping. Does it work? I wonder I do indeed wonder", 10, varArray)
Debug.Print "'" & varArray(I) & "'"
Next I
For I = 0 To StringX.WordWrapVar("Right! Now this is another test surely this wiiiiiiiiiiiiiiil breaaaaaaaaaaaakkkkkk it won't it? Does it work? I wonder I do indeed wonder", 10, varArray)
Debug.Print "'" & varArray(I) & "'"
Next I
For I = 0 To StringX.WordWrapVar("Test", 2, varArray)
Debug.Print "'" & varArray(I) & "'"
Next I
For I = 0 To StringX.WordWrapVar("this is a test of wordwrapping. Does it work? I wonder I do indeed wonder", 20, varArray)
Debug.Print "'" & varArray(I) & "'"
Next I
For I = 0 To StringX.WordWrapVar("this is a test of WordWrapping. Does it work? I wonder I do indeed wonder", 10, varArray, False)
Debug.Print "'" & varArray(I) & "'"
Next I
For I = 0 To StringX.WordWrapVar("Right! Now this is another test surely this wiiiiiiiiiiiiiiil breaaaaaaaaaaaakkkkkk it won't it? Does it work? I wonder I do indeed wonder", 10, varArray, False)
Debug.Print "'" & varArray(I) & "'"
Next I
For I = 0 To StringX.WordWrapVar("Test", 2, varArray, False)
Debug.Print "'" & varArray(I) & "'"
Next I
For I = 0 To StringX.WordWrapVar("this is a test of wordwrapping. Does it work? I wonder I do indeed wonder", 20, varArray, False)
Debug.Print "'" & varArray(I) & "'"
Next I
Debug.Print "*****"
Debug.Print


''=========================================================================
''StringEncrypt
'
' Encrypts a string according to a password, or randomly if password omitted

' =========================================================================
Debug.Print "StringEncrypt"
I = StringX.StringEncrypt("THIS IS A TEST", "EGG")
Debug.Print "'" & I & "'"
I = StringX.StringEncrypt("THIS IS A TEST", "BANANA")
Debug.Print "'" & I & "'"
I = StringX.StringEncrypt("THIS IS A TEST", "LEMON")
Debug.Print "'" & I & "'"
I = StringX.StringEncrypt("THIS IS A TEST")
Debug.Print "'" & I & "'"
I = StringX.StringEncrypt("THIS IS A TEST")
Debug.Print "'" & I & "'"
Debug.Print "*****"
Debug.Print

Debug.Print "StringEncrypt"
I = StringX.StringDecrypt("hrd", "EGG")
Debug.Print "'" & I & "'"
I = StringX.StringDecrypt("9$t5I$", "BANANA")
Debug.Print "'" & I & "'"
I = StringX.StringDecrypt("|7#wLd-H", "LEMON")
Debug.Print "'" & I & "'"
I = StringX.StringDecrypt("c1P;7u:#", "LEMON")
Debug.Print "'" & I & "'"
Debug.Print "*****"
Debug.Print



''=========================================================================
''WordDelete
'
' Deletes a word from a string

' =========================================================================
Debug.Print "WordDelete"
I = StringX.WordDelete("THIS IS A TEST", 2)
Debug.Print "'" & I & "'"
I = StringX.WordDelete("THIS. IS A TEST", 1)
Debug.Print "'" & I & "'"
I = StringX.WordDelete("THIS IS A TEST", 4)
Debug.Print "'" & I & "'"
I = StringX.WordDelete("THIS IS A TEST.", 4)
Debug.Print "'" & I & "'"
I = StringX.WordDelete("THIS", 1)
Debug.Print "'" & I & "'"
I = StringX.WordDelete("A TEST", 4)
Debug.Print "'" & I & "'"
I = StringX.WordDelete("", 0)
Debug.Print "'" & I & "'"
I = StringX.WordDelete("THIS IS A TEST", 2, True)
Debug.Print "'" & I & "'"
I = StringX.WordDelete("THIS IS A TEST", 1, True)
Debug.Print "'" & I & "'"
I = StringX.WordDelete("THIS IS A TEST", 4, True)
Debug.Print "'" & I & "'"
I = StringX.WordDelete("THIS IS A TEST.", 4, True)
Debug.Print "'" & I & "'"
I = StringX.WordDelete("THIS", 1, True)
Debug.Print "'" & I & "'"
I = StringX.WordDelete("A TEST", 4, True)
Debug.Print "'" & I & "'"
I = StringX.WordDelete("", 0, True)
Debug.Print "'" & I & "'"
Debug.Print "*****"
Debug.Print

''=========================================================================
''WordFind
'
' Finds a word from a string

' =========================================================================
Debug.Print "WordFind"
I = StringX.WordFind("THIS IS A TEST", "IS")
Debug.Print "'" & I & "'"
I = StringX.WordFind("THIS IS. A TEST", "IS")
Debug.Print "'" & I & "'"
I = StringX.WordFind("THIS. IS A TEST", "THIS")
Debug.Print "'" & I & "'"
I = StringX.WordFind("THIS IS A TEST", "IS")
Debug.Print "'" & I & "'"
I = StringX.WordFind("THIS IS A TEST", "TEST")
Debug.Print "'" & I & "'"
I = StringX.WordFind("THIS IS A TEST.", "IS")
Debug.Print "'" & I & "'"
I = StringX.WordFind("THIS.IS.A.TEST.", "TEST")
Debug.Print "'" & I & "'"
Debug.Print "*****"
Debug.Print

''=========================================================================
''InstrPackedDecimal
'
' Returns the Nth packed decimal field in string of pack decimal only fields
'
' =========================================================================
Debug.Print "InstrPackedDecimal"

Dim ThreePackDecimalFields As String

ThreePackDecimalFields = StringX.Hex2String("30432C") & StringX.Hex2String("112C") & StringX.Hex2String("9212212F")

I = StringX.InstrPackedDecimal(1, ThreePackDecimalFields)
Debug.Print "'" & I & "'"

I = StringX.InstrPackedDecimal(2, ThreePackDecimalFields)
Debug.Print "'" & I & "'"

I = StringX.InstrPackedDecimal(3, ThreePackDecimalFields)
Debug.Print "'" & I & "'"

I = StringX.InstrPackedDecimal(4, ThreePackDecimalFields)
Debug.Print "'" & I & "'"

I = StringX.InstrPackedDecimal(1, StringX.Hex2String("3043AA") & _
                                  StringX.Hex2String("112C") & _
                                  StringX.Hex2String("9212212C"))
Debug.Print "'" & I & "'"

I = StringX.InstrPackedDecimal(3, StringX.Hex2String("3043AA") & _
                                  StringX.Hex2String("112C") & _
                                  StringX.Hex2String("0C"))
Debug.Print "'" & I & "'"

I = StringX.InstrPackedDecimal(5, StringX.Hex2String("0C1D1C1D1D9F"))

Debug.Print "'" & I & "'"
Debug.Print "*****"
Debug.Print
''=========================================================================
''PackedDecimalLen
'
' Returns the length of the valid packed decimal field at specified position
' If the field isn't packed decimal then returns -1
'
' =========================================================================
Debug.Print "PackedDecmalLen"


ThreePackDecimalFields = StringX.Hex2String("30432C") & StringX.Hex2String("112C") & StringX.Hex2String("9212212F")

I = StringX.PackedDecimalLen(1, ThreePackDecimalFields)
Debug.Print "'" & I & "'"

I = StringX.PackedDecimalLen(4, ThreePackDecimalFields)
Debug.Print "'" & I & "'"

I = StringX.PackedDecimalLen(6, ThreePackDecimalFields)
Debug.Print "'" & I & "'"


I = StringX.PackedDecimalLen(1, "rubbish")
Debug.Print "'" & I & "'"


Debug.Print "*****"
Debug.Print

''=========================================================================
''GetPackedDecimalPos
'
' Searches a string of packed decimal only fields
' and returns the position of the nth valid packed decimal field.
'
'
' =========================================================================
Debug.Print "GetPackedDecmalPos"


ThreePackDecimalFields = StringX.Hex2String("30432C") & StringX.Hex2String("112C") & StringX.Hex2String("9212212F")

I = StringX.GetPackedDecimalPos(1, ThreePackDecimalFields)
Debug.Print "'" & I & "'"

I = StringX.GetPackedDecimalPos(2, ThreePackDecimalFields)
Debug.Print "'" & I & "'"

I = StringX.GetPackedDecimalPos(3, ThreePackDecimalFields)
Debug.Print "'" & I & "'"


I = StringX.GetPackedDecimalPos(1, "rubbish")
Debug.Print "'" & I & "'"


Debug.Print "*****"
Debug.Print

''=========================================================================
''GetWinDir
'
' Returns the users Windows installation directory
' =========================================================================
Debug.Print "GetWinDir"
Debug.Print StringX.GetWinDir
Debug.Print "*****"
Debug.Print
''=========================================================================
''GetSysDir
'
' Returns the users Windows system installation directory
' =========================================================================
Debug.Print "GetSysDir"
Debug.Print StringX.GetSysDir
Debug.Print "*****"
Debug.Print
''=========================================================================
''GetTempFilename
'
' Returns a system generated temporary filename
' =========================================================================
Debug.Print "GetTempFilename"
Debug.Print StringX.GetTempFile("TEST")
Debug.Print "*****"
Debug.Print

''=========================================================================
''ZonedDecimalToString
'
' Converts an IBM Zoned decimal field to a decimal string
' =========================================================================
Debug.Print "ZonedDecimalToString"
x = StringX.Hex2String("F1F2F3C4")  'Zoned decimal for +1234
Debug.Print StringX.ZonedDecimalToString(x)

x = StringX.Hex2String("D1")  'Zoned decimal for -1
Debug.Print StringX.ZonedDecimalToString(x)

x = StringX.Hex2String("F1F3F3F6F9F0F2F3F4")  'Zoned decimal for +133690234
Debug.Print StringX.ZonedDecimalToString(x)

x = StringX.Hex2String("C0")                  'Zoned decimal for 0
Debug.Print StringX.ZonedDecimalToString(x)

x = StringX.Hex2String("F0")                  'Zoned decimal for 0 also
Debug.Print StringX.ZonedDecimalToString(x)

x = StringX.Hex2String("A0")                                                 'invalid
Debug.Print StringX.ZonedDecimalToString(x)
Debug.Print "*****"
Debug.Print
''=========================================================================
''StringToZonedDecimal
'
' Converts an a decimal string to IBM Zoned decimal field
' =========================================================================
Debug.Print "StringToZonedDecimal"
x = StringX.StringToZonedDecimal("122232")
Debug.Print StringX.string2hex(x)
x = StringX.StringToZonedDecimal("+1")
Debug.Print StringX.string2hex(x)
x = StringX.StringToZonedDecimal("-123")
Debug.Print StringX.string2hex(x)
x = StringX.StringToZonedDecimal("0")
Debug.Print StringX.string2hex(x)
x = StringX.StringToZonedDecimal("+0")
Debug.Print StringX.string2hex(x)
x = StringX.StringToZonedDecimal("Garbage")                                 'Invalid
Debug.Print x
Debug.Print "*****"
Debug.Print

''=========================================================================
''PICtoStringDecimal
'
' Converts a COBOL Type PIC field to a decimal string.
' Use the first parm as the offset into the data. **NOTE that this offset is
' a HALFBYTE offset, not the normal byte offset as with Mid$ or Left$.
' This is because COBOL PIC fields are sometimes offset by half a byte.
' The second parm is the length of the PIC field. ie, 5 for a PIC field of length
' 5. This again equates to half bytes.
'
' The third parm is the actual data.
'
' IF YOU REQUIRE ANY HELP WITH PIC DATA PLEASE SEND US AN EMAIL WE ARE ONLY
' TOO HAPPY TO HELP. A SAMPLE DATA FILE WILL EASE OUR FREE INVESTIGATION.
'
' =========================================================================
Debug.Print "PICtoStringDecimal"
Debug.Print StringX.PICtoStringDecimal(0, 5, StringX.Hex2String("153320404040"))
Debug.Print StringX.PICtoStringDecimal(1, 5, StringX.Hex2String("015332404040"))
Debug.Print StringX.PICtoStringDecimal(3, 7, StringX.Hex2String("00015332404040"))
Debug.Print StringX.PICtoStringDecimal(1, 3, "")                       'Invalid
Debug.Print StringX.PICtoStringDecimal(1, 5, StringX.Hex2String("01"))
Debug.Print StringX.PICtoStringDecimal(1, 20, StringX.Hex2String("01"))
Debug.Print StringX.PICtoStringDecimal(0, 0, StringX.Hex2String("015332"))  'Invalid
Debug.Print "*****"
Debug.Print


''=========================================================================
''IsFile
'
' Checks if a file exists or not
' =========================================================================
Debug.Print "IsFile"
Debug.Print StringX.IsFile("C:\WINDOWS\WIN.INI")
Debug.Print StringX.IsFile("C:\TEST.TEST")
Debug.Print "*****"
Debug.Print




''=========================================================================
''GetRandomAlphaNumerics
'
' Generates a string of random alphanumerics of specified length
' =========================================================================
Debug.Print "GetRandomAlphaNumerics"
Debug.Print StringX.GetRandomAlphaNumerics(10)
Debug.Print StringX.GetRandomAlphaNumerics(1)
Debug.Print StringX.GetRandomAlphaNumerics(5)
Debug.Print StringX.GetRandomAlphaNumerics(0)
Debug.Print "*****"

Debug.Print

''=========================================================================
''GetRandomAlpha
'
' Generates a string of random alphabetic chars of specified length
' =========================================================================
Debug.Print "GetRandomAlpha"
Debug.Print StringX.GetRandomAlpha(10)
Debug.Print StringX.GetRandomAlpha(1)
Debug.Print StringX.GetRandomAlpha(5)
Debug.Print StringX.GetRandomAlpha(0)
Debug.Print "*****"
Debug.Print

''=========================================================================
''GetRandomNumerics
'
' Generates a string of random numerics of specified length
' =========================================================================
Debug.Print "GetRandomNumerics"
Debug.Print StringX.GetRandomNumerics(10)
Debug.Print StringX.GetRandomNumerics(1)
Debug.Print StringX.GetRandomNumerics(5)
Debug.Print StringX.GetRandomNumerics(0)
Debug.Print "*****"
Debug.Print


''=========================================================================
''GetOrdinal
'
' Returns the numeric ordinal for a number
' =========================================================================
Debug.Print "GetOrdinal"
Debug.Print StringX.GetOrdinal(1)
Debug.Print StringX.GetOrdinal(2)
Debug.Print StringX.GetOrdinal(3)
Debug.Print StringX.GetOrdinal(31)
Debug.Print StringX.GetOrdinal(423432)
Debug.Print StringX.GetOrdinal(433434)
Debug.Print "*****"
Debug.Print



''=========================================================================
''StringExecuteVB6
'
' Executes a string as if it were a VB6 statement!
' Optional parm to specify to validate the statement only
' =========================================================================
Debug.Print "GetRandomNumerics"

StringX.StringExecuteVB6 ("Debug.print ""This is a statment on the fly"" ")

I = 100
StringX.StringExecuteVB6 ("Debug.print " & I)

StringX.StringExecuteVB6 ("debug.print 2 + 2")
StringX.StringExecuteVB6 ("debug.print (1 /3) * (6 + 3)")

'Validate the statement only
Debug.Print StringX.StringExecuteVB6("An invalid statement", True)

Debug.Print "*****"
Debug.Print


'=========================================================================
'SearchArray
'
'A fast text array search string case sensitive
'=========================================================================
Debug.Print "SearchArray"
 
'Create a very large array full of text. This takes a moment....
Dim strArray2(9999) As String

For I = 1 To 9999
    strArray2(I) = "TDSAHASDALDJLKAJLKSDLKJASJKLDJKLASDLJAJKLSDLJAJKLSDJLKASDLJAJLKDJL"
Next I

'Add out test search element halfway in
strArray2(5000) = "THIS IS A TEST"

'Do the searches...
Debug.Print StringX.SearchArray(strArray2, "TEST", 0, True)

'Full match is actually faster
Debug.Print StringX.SearchArray(strArray2, "THIS IS A TEST", 0, False)

'No match returns -1
Debug.Print StringX.SearchArray(strArray2, "XXXXXXXXXXXX", 0, False)

'Bad call
Debug.Print StringX.SearchArray(strArray2, "XXXXXXXXXXXX", 999999999, False)

Debug.Print "*****"
Debug.Print


'=========================================================================
'cStringFast demonstration
''You can use this class the same way you use a string. However it is
'in most cases, much faster. Especially for longer strings. Try it and see.
'
'This is some demonstration code for concatenation of strings (notoriously
'slow in Visual Basic)
'
'=========================================================================

'Define the string
Dim strTest As New cStringFast

'Assign a value
strTest.Value = "TEST"

'Concatenate a string 5000 times
For I = 1 To 5000
    strTest.Concat "THIS IS A TEST TO MAKE A VERY LONG STRING VERY QUICKLY"
Next I

'put the result and length to the debug window
Debug.Print strTest.Value
Debug.Print strTest.Length


'Just for your own reference, uncomment and please try the these instructions to
'see how fast the traditional way of concatenating a string would take! (you will be in for a long wait!)

'Define the string
'Dim strTest2 As String

'Assign a value
'strTest2 = "TEST"

'Concatenate a string 5000 times
'For I = 1 To 5000
'    strTest2 = strTest2 & "THIS IS A TEST TO MAKE A VERY LONG STRING VERY SLOWLY "
'Next I

'put the result and length to the debug window
'Debug.Print strTest2
'Debug.Print Len(strTest2)












End Sub









